﻿-- -------------------
-- Approximationen
-- -------------------

SELECT SDO_GEOM.SDO_ARC_DENSIFY (geo,0.001,'arc_tolerance=0.05')
FROM GeoDbLand
WHERE name = 'Wall';

-- minimal umgebendes Rechteck:
SELECT SDO_GEOM.SDO_MBR(geo) FROM GeoDbLand WHERE name = 'Wall';

SELECT g.geo.ST_ENVELOPE() FROM MMSpatialLand g WHERE name = 'Wall';

SELECT ENVELOPE(geo) FROM MMSpatialLand WHERE name = 'Wall';

-- Konvexe Hülle:
SELECT SDO_GEOM.SDO_CONVEXHULL(geo,0.0001)
FROM GeoDbLand WHERE name = 'Steg';

SELECT g.geo.ST_CONVEXHULL()
FROM MMSpatialLand g WHERE name = 'Steg';

SELECT CONVEXHULL(geo)
FROM MMSpatialLand WHERE name = 'Steg';

-- nicht minimale Ergebnisse haben:
SELECT SDO_GEOM.SDO_CONVEXHULL(geo,0.0001)
FROM GeoDbLand WHERE name = 'Wall';

SELECT g.geo.ST_CONVEXHULL()
FROM MMSpatialLand g WHERE name = 'Wall';

-- Konkave Hülle:
SELECT SDO_GEOM.SDO_CONCAVEHULL_BOUNDARY(
         SDO_AGGR_UNION(SDOAGGRTYPE(
           SDO_GEOMETRY(2001,NULL,SDO_POINT_TYPE(t.x,t.y,NULL),NULL,NULL),
         0.001)),
       0.001,10)
FROM GeoDbLand g, TABLE(SDO_UTIL.GETVERTICES(g.geo)) t;

SELECT SDO_GEOM.SDO_CONCAVEHULL_BOUNDARY(
         SDO_AGGR_UNION(SDOAGGRTYPE(
           SDO_GEOMETRY(2001,NULL,SDO_POINT_TYPE(t.x,t.y,NULL),NULL,NULL),
         0.001)),
       0.001,5)
FROM GeoDbLand g, TABLE(SDO_UTIL.GETVERTICES(g.geo)) t;

-- Konkave Hülle mit Ursprungsdaten:
SELECT SDO_GEOM.SDO_CONCAVEHULL_BOUNDARY(
         SDO_AGGR_UNION(SDOAGGRTYPE(
           SDO_GEOMETRY(2001,NULL,SDO_POINT_TYPE(t.x,t.y,NULL),NULL,NULL),
         0.001)),
       0.001,5)
FROM GeoDbLand g, TABLE(SDO_UTIL.GETVERTICES(g.geo)) t
UNION ALL
SELECT SDO_GEOMETRY(2001,NULL,SDO_POINT_TYPE(t.x,t.y,NULL),NULL,NULL)
FROM GeoDbLand g, TABLE(SDO_UTIL.GETVERTICES(g.geo)) t;

-- Generalisierung:

SELECT gebiet, SDO_UTIL.SIMPLIFY(gebiet,500) FROM Ortsnetze WHERE name = 'Lilienthal';
